﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Controls.Maps;

namespace XamMapTileSource
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Point> points = new List<Point>();
        SurfaceElement surfaceElement;
        MapPolylineCollection lines = new MapPolylineCollection();
        public MainWindow()
        {
            InitializeComponent();

        }

        private void States_Loaded(object sender, RoutedEventArgs e)
        {
         
                // Points to make the shape
                points.Add(new Point(-74.535 - 2, 40.246 - 1));
                points.Add(new Point(-74.535 + 2, 40.246 - 1));
                points.Add(new Point(-74.535 + 4, 40.246 + 1));
                points.Add(new Point(-74.535 - 4, 40.246 + 1));

                // Convert Geodetic to Cartesian coordinates
                lines.Add(MyMap.MapProjection.ProjectToMap(points));

                // Create surface element and position shape using polylines
                surfaceElement = new SurfaceElement() { Name = "surfaceElement", Polylines = lines, Fill = new SolidColorBrush(Colors.Brown) };

                MyMap.Layers[0].Elements.Add(surfaceElement);

                Rect worldRect = surfaceElement.WorldRect;
                worldRect = lines.GetWorldRect();
                surfaceElement.WorldRect = worldRect;
            
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            MyMap.Layers[0].Elements.Remove(surfaceElement);

            points[0] = new Point(-74.535 + 2, 40.246 + 3);
            points[1] = new Point(-74.535 + 6, 40.246 + 3);
            points[2] = new Point(-74.535 + 8, 40.246 + 5);
            points[3] = new Point(-74.535 , 40.246 + 5);
            lines.RemoveAt(0);
            lines.Add(MyMap.MapProjection.ProjectToMap(points));
            surfaceElement = new SurfaceElement() { Polylines = lines, Fill = new SolidColorBrush(Colors.Brown) };

            MyMap.Layers[0].Elements.Add(surfaceElement);

            Rect worldRect = surfaceElement.WorldRect;
            worldRect = lines.GetWorldRect();

            surfaceElement.WorldRect = worldRect;

            MyMap.Layers[0].Elements.Add(surfaceElement);


            
        }       

   
      

        
    }
}
